'****************************************************************************************************
'                  DF PLAYER Ver.1.1 SW UART - DEMO PRIMJER 2 - zaustavlja Do-Loop petlju

' Ovo je DEMO program za ucenje koristenja naredbi DF Playera u Ver. 1.1

' Koristi ATmega328P (moze i ATmega8), moze ovisno o chipu bilo koji radni takt(izabran je 16MHz)

' VAZNO! Koristi softverski UART, sa J2 spoji PB.0 i TX, sa J1 spoji PD.1 i Key1

' Ne koristi DS3231 RTC

' Tipka Key0 - izgovaraju se iznosi brojeva upisani u niz od 10 Single varijabli

' Tipka Key1 - naredbom Say Lab_message izgovaraju se redom brojevi od 1 do 10

' Tipka Key2 - demo reprodukcija mp3 "Shallow" naredbom Say Lab_message

' Tipka Key3 - demo reprodukcija mp3 Gibonni "Vrime da se pomirim sa svitom" naredbom Say Lab_message

' Tipka Key4 - ukljucuje LED potprogramom Urgent

 'U ovom primjeru ne koriste se naredbe koje ovise o varijabli Language

' Izgovor ce ovisiti samo o MP3 direktoriju na SD kartici (engleskom ili hrvatskom)

' U program je potrebno ukljuciti datoteku MP3.bas u programu koristenih mp3 zapisa
'-----------------------------------------------------------------------------------------------------
'Za vrijeme reprodukcije zaustavlja prolaz kroz Do-Loop petlju

'Softverski UART: za TX je izabran PB.0 , za Busy = PB.1 ; izbori po zelji

'Napomena:Za vrijeme slanja podatka na DF Player onemoguceni su svi interapti

'Sa $include "dfplayer1_1.inc" u program ukljuciti slijedece naredbe za DF player:

'Dfplayer Command, Parameter - naredba slanja komande i opciono parametra na DF player

'najcesca Dfplayer naredba je: Dfplayer Mp3, x  (x je brojcani naziv mp3 zapisa u direktoriju MP3)

'Say Lab_message  -  naredba slanja poruke ili mp3 muzike na DF Player

'Say_number x - izgovor broja iz Single varijable x (opseg broja je od -9999.9 do 9999.9)

'Say_temperature x - izgovor temperature iz Single varijable x i mjerne jedinice za temperaturu

'Say_day - izgovor dana u tjednju iz Byte varijable Day

'Say_date - izgovor datuma, mjeseca i godine (hrvatski ili englesni standard izgovora)

'iz Byte varijabli Dte, Month i Year (brojevi u dekatskom obliku)

'Say_time - izgovor vremena HH:MM iz Byte varijabli Hour i Minute(sadrzaj u dekatskom obliku)

'Byte varijable Day, Hour, Minute, Dte, Month i Year dimenzionirane su u biblioteci "dfplayer1_1.inc"

'Sve navedene naredbe za DF player mogu se koristiti izvan ili unutar Do-Loop petlje

'Pocetna glasnoca je 28, a ekvilajzer je na Normal

'VAZNO! Naredbe DF Playera u Ver.1.1 ne koriste interapte;TIMER0, TIMER1 i TIMER2 slobodni za upotrebu

'Radni takt moze biti bilo koji do maksimalno dozvoljenog ovisno o mikrokontroleru

'Autor: Mladen Cempuh ; E-mail: cempuh.mladen@gmail.com

'Datum: 07.05.2021.
'******************************************************************************************************
$regfile = "m328pdef.dat"                                   ' za ATmega328P
'$regfile = "m8def.dat"                                      ' za ATmega8
$crystal = 16000000                                         ' izabran radni takt 16MHz , moze biti bilo koji ovisno o kontroleru
$swstack = 50
$hwstack = 50                                               ' za DF Player Ver.1.2  HW Stack treba biti >= 50, po potrebi povecaj
$framesize = 64

'---------------------------------------------------------
'DEFINIRANJE ULAZA,IZLAZA I POCETNIH STANJA PINOVA PORTOVA
'DDRn   PORTn
' 0       0   ==> Input 3-state
' 0       1   ==> Input
' 1       0   ==> Output=0
' 1       1   ==> Output=1

  Ddrb = &B11111101                                         ' izlaz PB.0 za TX, ulaz PB.1 za Busy, PB.2 izlaz za LED, PB3 izlaz za rasvjetu LCD-a
 Portb = &B11001011                                         ' Izlazi za LCD: DB7=PB.4;DB6=PB.5;DB5=PC.2;DB4=PC.3;E=PC.4;RS=PC.5
  Ddrc = &B11111100                                         ' PC.0 i PC.1 su slobodni ulazi
 Portc = &B00000011                                         '
  Ddrd = &B11100000                                         ' Ulazi za tipke KEY0=PD.0;KEY1=PD.1;KEY2=PD.2;KEY3=PD.3;KEY4=PD.4
 Portd = &B11111111                                         ' PD5,PD6 i PD7 su slobodni za koristenje (startno postavljeni kao izlazi sa stanjem 1)


'---------------------------------------------------------
'DEFINIRANJE LCD DISPLEJA U 4 BITNOM RADU

Config Lcd = 16 * 2
Config Lcdpin = Pin , Db4 = Portc.3 , Db5 = Portc.2 , Db6 = Portb.5 , Db7 = Portb.4 , Rs = Portc.5 , E = Portc.4
Cls
Cursor Off

'-----------------------------------------------------------------------------------------------------------------
'Definiraj izlaz TX i ulaz Busy, a zatim ukljuci biblioteku "dfplayer1_1.inc"

'Konfiguracija Software UART-a za DF Player:

Open "comb.0:9600,8,n,1" For Output As #1                   'PB.0 za TX , RX se ne koristi

                                                              'Baud=9600, 8 Bits, No parity, 1 Stop bit
'Definiraj ulaz Busy:

Busy Alias Pinb.1

Config Busy = Input                                         ' ulaz za Busy sa DF Playera, 1=slobodan , 0= zauzet

$include "dfplayer1_1.inc"                                  ' biblioteka za DF Player u Ver.1.1 (softverski UART)

'Language = 1                                                ' 1 = hrvatski , 0 = engleski , u ovom primjeru nevazno
'--------------------------------------------------------------------------------------------------------------------
'Definiranje 5 tipki spojenih na PORTD i GND

Key0 Alias Pind.0
Key1 Alias Pind.1
Key2 Alias Pind.2
Key3 Alias Pind.3
Key4 Alias Pind.4


Led Alias Portb.2

'Config Led = Output                                         ' vec je definirano  kao izlaz sa DDRB
'--------------------------------------------------------------------------------------------------

'  Dfplayer Volume , 31                                      'pocetna glasnoca je 28,opciono promjeni glasnocu npr. na 31 --> maksimum
'  Waitms 200                                                'pauza za izvrsenje naredbe
'----------------------------------------------------------------------------------------------------------------------

  Dim X(10) As Single , I As Byte , Y As Single , W As Word , D As Byte , Predznak As Byte , C As Byte

'Niz Single varijabli za izgovor:

  X(1) = -1800.2 : X(2) = 51.9 : X(3) = 1513 : X(4) = 0 : X(5) = -0.9 : X(6) = 815.2 : X(7) = 7000 : X(8) = -250.7 : X(9) = 505 : X(10) = -9601.3

  Locate 1 , 1 : Lcd "DF Player Ver1.1"

  Locate 2 , 1 : Lcd "Demo primjer 2"

  Wait 2

  Cls

Do

Locate 1 , 1 : Lcd "DF Player Ver1.1"

Locate 2 , 1 : Lcd "Select key 0 - 4"

   Debounce Key0 , 0 , Say_numbers , Sub                    ' pritiskom na tipku Key0 izgovaraju se brojcani iznosi niza od 10 Single varijabli

   Debounce Key1 , 0 , Numbers_1to10 , Sub                  ' pritiskom na tipku Key1 izgovara redom brojeve od 1 do 10  naredbom Say Lab_message

   Debounce Key2 , 0 , Shallow_mp3 , Sub                    ' pritiskom na tipku Key3 reproducira mp3 pjesmu "Shallow" naredbom Dfplayer Mp3 , x

   Debounce Key3 , 0 , Gibonni_mp3 , Sub                    ' pritiskom na tipku Key3 reproducira mp3 pjesmu Gibonni "Vrime da se pomirim sa svitom"


   Gosub Urgent                                             ' potprogram kojim se nadziru vazna stanja neovisno o reprodukciji

Loop

'---------------------------------------------------------

Say_numbers:

   Cls

   Lcd "Say X(1)...X(10)"

   For I = 1 To 10                                          ' ispis na LCD i izgovor brojcanih iznosa niza od 10 Single varijabli

   Locate 2 , 1 : Lcd "X(" ; I ; ")=" ; Fusing(x(i) , "####.#") ; "     "       ' ispis Single varijable X(i) zaokruzi na jednu decimalu

   Say_number X(i)                                          ' reci brojcani iznos Single varijable X(i)

   Say Pause_2s                                             ' tisina 2s za vrijeme koje se izvrsava potprogram Urgent
                                                            ' za razliku od npr. Wait 2 kad se nista ne izvrsava
   Next I

Return

'-----------------------------------------------------------
Numbers_1to10:

  Cls

  Lcd "Broji 1 ... 10"

  Say Broji_1do10                                           ' naredbom Say Lab_message izgovara redom brojeve od 1 do 10

Return
'-----------------------------------------------------------
Shallow_mp3:

  Cls

  Lcd "Muzika: Shallow"

  Say Shallow                                               'naredbom Say Lab_message reproducira mp3 zapis pjesme "Shallow", demo izvedba

Return
'-----------------------------------------------------------
Gibonni_mp3:

  Cls

  Lcd "Muzika: Gibonni"

  Say Gibonni                                               'naredbom Say Lab_message reproducira mp3 Gibonni "Vrime da se pomirim sa svitom",demo izvedba

Return

'-----------------------------------------------------------
Urgent:

 If Key4 = 0 Then                                           ' ako je pritisnuta tipka Key4 ukljuci Led

      Set Led

   Else

    Reset Led                                               ' u protivnom iskljuci Led

   End If

Return

End

$include "MP3.bas"                                          'datoteka u programu koristenih mp3 zapisa