'-------------------------------------------------------------------------------------------------------------
' Biblioteka za DF Player 1.2 preko HW UART - Za vrijeme reprodukcije zaustavlja izvrsavanja Do-Loop petlje

' Autor: Mladen Cempuh , Datum: 19.09.2021.  ; E-mail: cempuh.mladen@gmail.com
'-------------------------------------------------------------------------------------------------------------

'Napomena: Umetnuti u glavni program naredbom $include"dfplayer1_2si.inc"

'Podrzava izbor pravila izgovora varijablom Language = 0 --> engleski, 1 --> hrvatski , 2 --> slovenski

'Napomena: Za slanje podataka na DF Player koristi hardverski UART i TX = PD.1

'Koristi se TF card(micro SD), glasnoca je 28, ekvilajzer = 0 --> Normal

'Za vrijeme reprodukcije izvrsava se potprogram Urgent smjesten u glavnom programu

'Za vrijeme slanja naredbi i podataka u DF player ne onemogucava interapte

'Za rad DF playera ne koristi interapte, slobodni su za upotrebu TIMER0, TIMER1 i TIMER2

'Naredbe drivera za DF Player(izvan ili unutar Do-Loop petlje):

'Dfplayer Command, Parameter - naredba slanja komande i opciono parametra na DF player

'najcesca Dfplayer naredba je : Dfplayer Mp3 , x  'x je brojcani naziv mp3 zapisa u direktoriju MP3

'Say Lab_message  -  naredba slanja poruke na DF Player , poruka se nalazi npr. na labeli Lab_message

'Say_number x - izgovor broja iz Single varijable x (opseg broja je od -9999.9 do 9999.9)

'Say_temperature x - izgovor temperature iz Single varijable x (od -9999.9 do 9999.9) i izgovor jedinice Celzija

'Say_day - izgovor dana u tjednu iz Byte varijable Day

'Say_time - izgovor vremena (HH:MM) iz Byte varijabli Hour i Minute

'Say_date - izgovor datuma, mjeseca i godine iz Byte varijabli Dte, Month i Year
'---------------------------------------------------------------------------------------------------------------

'Upravljacke komande Dfplayer naredbe:

'Play_next Alias &H01                                        'reproduciraj slijedecu datoteku

'Play_prev Alias &H02                                        'reproduciraj prethodnu datoteku

'Play Alias &H03                                             'reproduciraj datoteku iz root direktorija (problem imenovanja!)

Volup Alias &H04                                            'uvecaj glasnocu za 1

Voldown Alias &H05                                          'smanji glasnocu za 1

Volume Alias &H06                                           'namjesti glasnocu na 0 do 31

Equlizer Alias &H07                                         'namjesti ekvilajzer , 0 = Normal

'Playmode Alias &H08                                         'izbor nacina ponavljanja reprodukcije

Source Alias &H09                                           'izaberi izvor zapisa datoteka, 1 =TF card = micro SD card

Standby Alias &H0A                                          'postavi  u Standby (Low Power)

Wakeup Alias &H0B                                           'Wakeup - izadji iz Standby moda u Normal

Resetmodule Alias &H0C                                      'software-ski reset DF Playera

'Playback Alias &H0D                                         'nastavi pauziran zapis

'Pause Alias &H0E                                            'pauziraj trenutnu reprodukciju

'Specfolderplay Alias &H0F                                   'izaberi folder za reprodukciju

'Voladjust Alias &H10                                        ' namjestanje glasnoce (drugi nacin)

'Repeatplay Alias &H11                                       'toggle ponavljanja reprodukcije svih datoteka 1=Start repeat, 0=Stop repeat

Mp3 Alias &H12                                              'reprodukcija izabrane mp3 datoteke (1 do 9999) iz MP3 foldera

'Start_advert Alias &H13                                     'prekida trenutnu reprodukciju i ubacuje reklamu iz ADVERT foldera

'Stop_advert Alias &H15                                      'zaustavlja reprodukciju reklame iz ADVERT foldera i nastavlja prethodno prekinutu reprodukciju

Stop_play Alias &H16                                        'zaustavlja reprodukciju trenutno reproducirane datoteke

'Repeat_folder Alias &H17                                    'ponovi reprodukciju izabranog foldera (1-99)

'Random_play Alias &H18                                      'random reprodukcija sa medija

'Repeat_play Alias &H19                                      'ponovna reprodukcija pokrenute datoteke

Amplifier_off Alias &H1A                                    'tiho iskljucivanje pojacala

'--------------------------------------------------------------------------------------------------------------------
'Hardverski UART za TX (PD.1):

$baud = 9600                                                ' baud rate 9600 bits/s, 8 bits, no parity, 1 stop bit

'Opcija koristenja izlaznog serijskog buffera:

'Config Serialout = Buffered , Size = 12                     ' buffer za serijski RS232 TX izlaz

'Enable Interrupts                                           ' tada je neophodno omoguciti  sve interapte (zbog UDRE interapta koji se koristi)
                                                              ' ako se ne koristi taj buffer nije potrebno omoguciti interapte
'---------------------------------------------------------------------------------------------------------------------
Tf_card Alias 1

Dim Say_label As Word , Mp3_file As Word , Take_data As Integer , Num_string As String * 7 , Ar(8) As Byte , _$index As Byte , First_digit As Byte

Dim _$cifra As Byte , Language As Byte                      ' za naredbu Say_temperature x

Dim Hour As Byte , Minute As Byte , Day As Byte             ' Byte varijable za naredbu Say_time  i Say_day

Dim Dte As Byte , Month As Byte , Year As Byte              ' Byte varijable za naredbu Say_date

Config Submode = New

Goto End_of_driver
'--------------------------------------------------------------------------------------------------------

Sub Dfplayer(byval Command As Byte , Byval Parameter As Word)

'Format slanja ($S ; Ver ; Len ; Cmd ; Feedback ; Para1 ; Para2 ; Checksum1 ; Checksum2 ; $O)

   Local _$s As Byte , _ver As Byte , _len As Byte , _$o As Byte , Feedback As Byte


   Local Checksum_ As Integer , Checksum1 As Byte , Checksum2 As Byte , Para1 As Byte , Para2 As Byte

   Para1 = High(parameter)

   Para2 = Low(parameter)

   _$s = &H7E                                               'Start command
   _ver = &HFF                                              'Version information
   _len = &H06                                              'Data lenght (od Version do Para2 (data_low DL)
   _$o = &HEF                                               'End command

'Izracun Checksuma:

   Feedback = 0                                             'bez feedbacka

   Checksum_ = _ver + _len
   Checksum_ = Checksum_ + Command
'  Checksum_ = Checksum_ + Feedback                         'Feedback = 0 pa nije ovaj red potreban
   Checksum_ = Checksum_ + Para1
   Checksum_ = Checksum_ + Para2
   Checksum_ = 0 - Checksum_
   Checksum1 = High(checksum_)
   Checksum2 = Low(checksum_)

'Posalji na TX preko HW UART-a:


   Print Chr(_$s) ; Chr(_ver) ; Chr(_len) ; Chr(command) ; Chr(feedback) ; Chr(para1) ; Chr(para2) ; Chr(checksum1) ; Chr(checksum2) ; Chr(_$o)


 Waitms 150                                                 'VAZNO!!!Pauza minimum 150ms za ispravnu detekciju signala Busy
                                                             '        nakon naredbe poslane na DF Player preko HW UART-a
                                                             'NAPOMENA: Ako preskace neke segmente govora tada povecaj tu pauzu!
Wait_busy:

 Gosub Urgent                                               ' korisnicki potprogram koji se izvrsava i za vrijeme reprodukcije

 If Busy = 0 Then Goto Wait_busy                            ' ceka zavrsetak reprodukcije izabrane datoteke da Busy postane 1

End Sub

'------------------------------------------------------------
'                Naredba: Say Lab_message
'------------------------------------------------------------

Sub Say(bylabel Lab_message As Word)

   Say_label = Lab_message

   lds _dptrl,{Say_label}                                   ' Napuni Data pointer sadrzajem argumenta Lab_message za naredbu Read
                                                            ' to je umjesto naredbe Restore kojom se Data pointer ne moze proslijediti
   LDS _dptrh,{Say_label+1}                                 ' u deklariranu subrutinu

Read_tab:

   Read Take_data                                           ' procitaj podatak sa mjesta oznacenog sadrzajem Data pointera iz Data tablice

   If Take_data <> 0 Then                                   ' 0=kraj tablice, ako nije nula tada

    Mp3_file = Take_data                                    'prebaci podatak u Word varijablu Mp3_file koja je argument naredbe Dfplayer Mp3

    Dfplayer Mp3 , Mp3_file                                 ' reproduciraj mp3 zapis sa TF card\MP3 izabran sadrzajem Word varijable Mp3_file

   Goto Read_tab                                            'slijedece citanje, Data pointer se nakon prethodne Read naredbe automatski uvecao
                                                             'na slijedecu poziciju u tablici
   End If

End Sub

'-------------------------------------------------------------
'                Naredba: Say_number x
'-------------------------------------------------------------

Sub Say_number(byval Number_for_say As Single)

   Num_string = Fusing(number_for_say , "####.#")           'pretvori u format 4 cjelobrojne cifre i jedna decimalna cifra

   For _$index = 1 To 8                                     'obrisi od array varijable od Ar(1) do Ar(8)

   Ar(_$index) = 0

   Next _$index

   Str2digits Num_string , Ar(1)                            'vidi znacenje naredbe Str2digits

   First_digit = 7                                          ' moguce mjesto prve cifre broja je u Ar(7)

   For _$index = 5 To 8                                     'pretrazi od Ar(5) do Ar(8)

   If Ar(_$index) = 253 Then                                ' ako nadjes broj 253, to je kod za "minus" tada

    Dfplayer Mp3 , 253                                      'reci "minus" (file: 253.mp3), broj je negativan

    Decr _$index                                            ' smanji _$indeks, pointer na prvoj cifri broja

    First_digit = _$index                                   ' stavi u varijablu First_digit podatak o pointeru prve cifre broja

    Goto Test_zero                                          ' idi na Test_zero

    End If

    Next _$index

' nije naden 253 (minus) -->broj je pozitivan

Test_zero:

   For _$index = First_digit To 4 Step -1

   If Ar(_$index) <> 0 Then Goto Cifre_broja                ' cjelobrojni dio nije nula i idi na citanje broja

   Next _$index

' cjelobrojni dio je 0

   Dfplayer Mp3 , 255                                       ' reci "nula" (file: 255.mp3)

   If Ar(2) = 0 Then Goto End_of_speak                      'i decimala je 0, broj je 0, zavrsi izgovor broja

   Gosub Say_decimal                                        ' u protivnom reci "cijelih" i decimalu

   Goto End_of_speak                                        ' i zavrsi izgovor broja

Cifre_broja:

   If _$index = 7 Then                                      ' postoji cifra tisucice

   Mp3_file = Ar(7) * 7

   Mp3_file = Mp3_file + 1000                               'izracunaj Name_of_mp3 za cifru tisucice

   Dfplayer Mp3 , Mp3_file                                  ' reci tisucicu broja

   Decr _$index                                             ' smanji pointer _$indeks na 6

   End If


   If _$index = 6 Then                                      'ispitaj stoticu

   If Ar(6) = 0 Then Goto Index_5                           ' stotica je 0 , preskoci na slijedecu cifru

   Mp3_file = Ar(6) * 6                                     'postoji cifra stotice

   Mp3_file = Mp3_file + 100                                'izracunaj Name_of_mp3 za cifru stotice

   Dfplayer Mp3 , Mp3_file                                  ' reci stoticu broja

Index_5:

   Decr _$index                                             ' smanji pointer  _$indeks na 5

   End If

   If _$index = 5 Then                                      ' ispitaj deseticu

    If Ar(5) = 0 Then Goto Index_4                          ' desetica je 0 , preskoci na slijedecu cifru

     If Ar(5) = 1 Then

      Mp3_file = Ar(4) + 10                                 'reci zajedno deseticu i jedinicu broja 10 do 19

       Dfplayer Mp3 , Mp3_file

      Goto Index_2                                          'preskoci zaseban izgovor jedinice

     Else

      If Language = 2 Then                                  ' za pravila slovenskog jezika

       If Ar(4) <> 0 Then                                   ' reci prvo jedinicu, a onda deseticu

        Mp3_file = Ar(4)                                    ' apsolutna vrijednost broja je < 10 i >= 1

        Dfplayer Mp3 , Mp3_file                             ' reci jedinicu broja

        Dfplayer Mp3 , 263                                  ' reci i

        Mp3_file = Ar(5) * 10                               'apsolutna vrijednost broja je >=20

        Dfplayer Mp3 , Mp3_file                             'reci deseticu broja

        Goto Index_2                                        'preskoci zaseban izgovor jedinice

       End If

      End If

      Mp3_file = Ar(5) * 10                                 'apsolutna vrijednost broja je >=20

      Dfplayer Mp3 , Mp3_file                               'reci deseticu broja

     End If

Index_4:

   Decr _$index                                             ' smanji  pointer _$indeks na 4

   End If


   If _$index = 4 Then                                      ' ispitaj jedinicu

     If Ar(4) = 0 Then Goto Index_2                         ' jedinica je 0, preskoci na decimalu

      Mp3_file = Ar(4)                                      'apsolutna vrijednost broja je < 10 i >= 1

      Dfplayer Mp3 , Mp3_file                               'reci jedinicu broja

     End If

Index_2:

     If Ar(2) = 0 Then Goto End_of_speak                    ' ako je Ar(2)=0 nema decimale, zavrsi izgovor broja

      Gosub Say_decimal                                     '  u protivno reci "cijeli" ili "cijela" ili "cijelih" i decimalu

End_of_speak:                                               ' kraj izgovora broja

End Sub
'-------------------------------------------------------------------------------------------------------------------
Say_decimal:

   Select Case Ar(4)

   Case 1 : Mp3_file = 257                                  '"cijeli"

   Case 2 To 4 : Mp3_file = 256                             '"cijela"

   Case Else : Mp3_file = 254                               '"cijelih"

   End Select

   Dfplayer Mp3 , Mp3_file                                  'reci "cijeli" ili "cijela" ili "cijelih"


   Mp3_file = Ar(2)                                         'uzmi u Mp3_file cifru decimale

   Dfplayer Mp3 , Mp3_file                                  ' i reci decimalu

   Return

'-----------------------------------------------------------
'                Naredba: Say_temperature x
'-----------------------------------------------------------

Sub Say_temperature(byval _$temperatura As Single)

  Say_number _$temperatura                                  ' izgovori brojcani iznos temperature

If Language = 0 Then                                        ' ako je Language=0 tadaseradi o engleskom jeziku

  If _$temperatura <= 1 Then                                ' tada za sve iznose temperature koji su <= 1 reci "degree Celsius"

     Dfplayer Mp3 , 21

  Else                                                      ' a ako je temperatura > 1 tada reci "degrees Celsius"

     Dfplayer Mp3 , 22

  End If

Else                                                        ' za hrvatski jezik pravilno reci tri mogucnosti izgovora jedinice Celzija

  If Ar(2) = 0 Then                                         ' "stupanj Celzija" ili "stupnja Celzija" ili "stupnjeva Celzija" ,

   _$cifra = Ar(4)                                          ' a ovisno o brojcanom iznosu temperature

  Else

   _$cifra = Ar(2)

  End If

  If Ar(2) = 0 And Ar(4) = 1 And Ar(5) = 1 Then

    Dfplayer Mp3 , 23                                       'stupnjeva  Celzija

  Goto Lab$_say_unit_celsius

  End If

  If Ar(2) = 0 And Ar(4) = 1 Then

   Dfplayer Mp3 , 21                                        'stupanj Celzija

   Goto Lab$_say_unit_celsius

  End If

  If Ar(2) = 1 Then

   Dfplayer Mp3 , 21                                        ' stupanj Celzija

    Goto Lab$_say_unit_celsius

  End If

  If _$cifra = 2 Or _$cifra = 3 Or _$cifra = 4 Then

   Dfplayer Mp3 , 22                                        'stupnja Celzija

   Goto Lab$_say_unit_celsius

   End If

   Dfplayer Mp3 , 23                                        'stupnjeva Celzija

Lab$_say_unit_celsius:

End If

End Sub

'--------------------------------------------------------------------------------
'                       Naredba:Say_time
'--------------------------------------------------------------------------------
Sub Say_time()

Dim Say$hour As Word , Say$minute As Word , Df$pm As Byte

   If Language = 0 Then                                     'Engleski izgovor:

     If Hour = 0 And Minute = 0 Then                        ' ako je vrijeme 00:00

      Dfplayer Mp3 , 28                                     ' reci "12 o'clock, midnight"

      Goto End_say_time                                     ' i zavrsi naredbu

     End If

     If Hour = 12 And Minute = 0 Then                       ' ako je vrijeme 12:00

      Dfplayer Mp3 , 29                                     ' reci "12 o'clock, noon"

      Goto End_say_time                                     ' i zavrsi naredbu

     End If

     If Hour >= 12 Then

      Say$hour = Hour - 12                                  'izracun sati za PM

      If Say$hour = 0 Then Say$hour = 12

      Df$pm = 1                                             ' 1 za PM

     Else

      Say$hour = Hour                                       ' sati za AM

      If Say$hour = 0 Then Say$hour = 12

      Df$pm = 0                                             ' 0 za AM

     End If

      Dfplayer Mp3 , Say$hour                               ' reci sate

     If Minute <> 0 Then                                    ' ako nije 0 minuta tada

      Say$minute = Minute + 500

      Dfplayer Mp3 , Say$minute                             ' reci minute

     End If

     If Df$pm = 0 Then

      Dfplayer Mp3 , 41                                     ' reci AM

     Else

      Dfplayer Mp3 , 42                                     ' reci PM

     End If

     Goto End_say_time                                      ' zavrsi naredbu

   Else                                                     ' Hrvatski izgovor:

     If Hour = 0 And Minute = 0 Then                        ' ako je vrijeme 00:00

       Dfplayer Mp3 , 28                                    ' reci "ponoc"

       Goto End_say_time                                    ' i zavrsi naredbu

     End If

     If Hour = 12 And Minute = 0 Then                       ' ako je vrijeme 12:00

       Dfplayer Mp3 , 29                                    ' reci "podne"

       Goto End_say_time                                    ' i zavrsi naredbu

     End If

    Say$hour = Hour + 560

    Dfplayer Mp3 , Say$hour                                 ' reci sate

    Dfplayer Mp3 , 263                                      'OPCIJA: reci "i"

    Say$minute = Minute + 500

    Dfplayer Mp3 , Say$minute                               ' reci minute

   End If

End_say_time:                                               ' zavrsi naredbu

End Sub

'--------------------------------------------------------------------------------
'                         Naredba:Say_day
'--------------------------------------------------------------------------------
Sub Say_day()

Dim Say$day As Word

  Say$day = Day + 30

  Dfplayer Mp3 , Say$day

End Sub

'--------------------------------------------------------------------------------
'                         Naredba: Say_date
'--------------------------------------------------------------------------------
Sub Say_date()

Dim Say$date As Word

  If Language = 0 Then                                      ' za engleski izgovor:

   If Dte > 12 Then

     Gosub Say_month                                        ' reci mjesec

     Gosub Say_dte                                          ' reci datum

   Else

     Gosub Say_dte                                          ' reci datum

     Gosub Say_month                                        ' reci mjesec

   End If

  Else                                                      ' za izgovor na hrvatskom:

   Gosub Say_dte                                            ' reci datum

   Gosub Say_month                                          ' reci mjesec

  End If

  Say$date = Year + 400

  Dfplayer Mp3 , Say$date                                   'reci godinu

  Goto End_say_date

Say_dte:

   Say$date = Dte + 300

   Dfplayer Mp3 , Say$date                                  'reci datum

   Return

Say_month:

   Say$date = Month + 200

   Dfplayer Mp3 , Say$date                                  ' reci mjesec

   Return

End_say_date:

End Sub
'----------------------------------------------------------------------------------------------------------------------
End_of_driver:

   Wait 2                                                   'pauza za inicijalizaciju DF Playera nakon ukljucenja napona

   Dfplayer Source , Tf_card                                ' koristi se TF card = micro SD
   Waitms 200

   Dfplayer Volume , 28                                     'namjesti glasnocu  na 28
   Waitms 200

   Dfplayer Equlizer , 0                                    'namjesti ekvilajzer na normal mod
   Waitms 200

'-------------------------------------------------------------------------------------------------