'**********************************************************************************************************
'                    DF PLAYER Ver.2 HW UART - DEMO PRIMJER 2 - ne zaustavlja Do-Loop petlju

' Ovo je DEMO program za ucenje koristenja naredbi DF Playera u Ver.2

' Koristi ATmega328P (moze i ATmega8); radni takt 16MHz (moze i 8MHz)

' VAZNO! Koristi hardverski UART,sa J2 spoji PD.1 i TX, sa J1 spoji PB.0 i Key1

' Ne koristi DS3231 RTC

' Tipka Key0 - izgovora brojcani iznos Single varijable X(i) i inkrementira index i do 10, a nakon toga je 1

' Tipka Key1 - izgovara redom brojeve od 1 do 10 naredbom Say Lab_messsage

' Tipka Key2 - demo reprodukcija naredbom Dfbuffer x, demo mp3 zapis "Shallow"

' Tipka Key3 - demo reprodukcija naredbom Say Lab_message, demo mp3 Gibonni "Vrime da se pomirim sa svitom"

' Tipka Key4 - upravlja LED diodom na izlazu PB.2 u Do-Loop petlji (za provjeru izvrsenja Do-Loop petlje)

' Pomocu linka Every_1s invertira izlaz PD.5 svake sekunde za prezentaciju koristenja linka Every_1s

' Iza naredbe End treba ukljuciti datoteku MP3.bas u programu koristenih mp3 zapisa

' Naredbe DF playera koje se koriste u ovom primjeru ne koriste varijablu Language
'------------------------------------------------------------------------------------------------------------
'Koristi Df buffer tako da za vrijeme reprodukcije ne zaustavlja prolaz kroz Do-Loop petlju

'TX = PD.1(hardverski UART) i Busy = PB.1 ; izbor po volji

'Sa $include "dfplayer2.inc" u program ukljuciti slijedece naredbe:

'Time_ms = x : Wait_ms - naredba interaptski izvrsava tocnu pauzu od x ms (zaustavlja Do_Loop)

'Moze se koristiti i 32 bitni brojac Millis koji broji ms od ukljucenja

'Na raspolaganju su i linkovi za brze rutine koje se izvrsavaju u periodi 1ms, 10ms, 100ms i 1s

'Za rad koristi Timer0 interapt, a slobodni su Timer1 i Timer2, treba omoguciti interapte

'Naredbe prije Do-Loop petlje:

'Dfplayer Command , Parameter - naredba slanja komande i opciono parametra na DF player

'najcesca Dfplayer naredba je : Dfplayer Mp3 , x  ; x je broj mp3 zapisa u direktoriju MP3

'Naredbe unutar Do-Loop petlje:

'Dfbuffer_enable - naredba se mora staviti samo jednom na pocetku Do-Loop petlje, a prije
'                  ostalih naredbi za DF player i omogucava pravilan rad Df buffera

'Dfbuffer x  -  naredba za upis u Df buffer ;  x je brojcani naziva mp3 zapisa iz MP3 direktorija

'Dfstop - prekida reprodukciju i brise Df buffer

'Say Lab_message  -  naredba slanja poruke u Df buffer , poruka se nalazi npr. na labeli Lab_message

'Say_number x - izgovor broja iz Single varijable x preko Df buffera (opseg broja je od -9999.9 do 9999.9)

'Say_temperature x - izgovor temperature iz Single varijable x

'Say_day - izgovor dana u tjednju sadrzanog u varijabli Day (1=ponedjeljak...7=nedjelja)

'Say_date - izgovor datuma, mjeseca i godine (hrvatski ili englesni standard izgovora)

'iz Byte varijabli Dte, Month i Year (brojevi u dekatskom obliku)

'Say_time - izgovor vremena HH:MM iz Byte varijabli Hour i Minute (sadrzaj u dekatskom obliku)

'Napomena:Za vrijeme trajanja reprodukcije blokiran je upis novih podataka u Df buffer (Df_flag=1)

'Moze se koristiti i 32 bitni brojac Millis koji se uvecava svake ms

'U ovom primjeru je LED = PB.2 za isprobavanje rada programa i za ERROR

'ERROR izlaz za prijavu greske : Buffer overload! (definirano u driveru "dfplayer2.inc")

'Upis u Df buffer radi se u Do-Loop petlji kad je Df_flag=0 (kad nema reprodukcije)

'Citanje Df buffera i slanje podataka na DF player izvrsava se u Timer0 interaptu svakih 150ms

'Autor: Mladen Cempuh ; E-mail: cempuh.mladen@gmail.com

'Datum: 23.05.2021.
'************************************************************************************************************
$regfile = "m328pdef.dat"
'$regfile = "m8def.dat"
$crystal = 16000000                                         ' izabrati ili 8MHz ili 16MHz
$swstack = 50
$hwstack = 60                                               ' VAZNO! iznos od 40 nije dovoljan za HWstack! Preporuka: =>60
$framesize = 64

'---------------------------------------------------------
'DEFINIRANJE ULAZA,IZLAZA I POCETNIH STANJA PINOVA PORTOVA
'DDRn   PORTn
' 0       0   ==> Input 3-state
' 0       1   ==> Input
' 1       0   ==> Output=0
' 1       1   ==> Output=1

  Ddrb = &B11111100                                         ' ulaz PB.0 za tipku KEY1,ulaz PB.1 za Busy, PB.2 izlaz za LED, PB3 izlaz za rasvjetu LCD-a
 Portb = &B11001011                                         ' Izlazi za LCD: DB7=PB.4;DB6=PB.5;DB5=PC.2;DB4=PC.3;E=PC.4;RS=PC.5
  Ddrc = &B11111100                                         ' PC.0 i PC.1 su slobodni ulazi
 Portc = &B00000011                                         '
  Ddrd = &B11100010                                         ' Ulazi za tipke KEY0=PD.0;KEY2=PD.2;KEY3=PD.3;KEY4=PD.4
 Portd = &B11111111                                         ' Izlaz PD.1 za TX hardverskog UART-a
                                                            ' PD5,PD6 i PD7 su slobodni za koristenje (startno postavljeni kao izlazi sa stanjem 1)
'---------------------------------------------------------
'DEFINIRANJE LCD DISPLEJA U 4 BITNOM RADU

Config Lcd = 16 * 2
Config Lcdpin = Pin , Db4 = Portc.3 , Db5 = Portc.2 , Db6 = Portb.5 , Db7 = Portb.4 , Rs = Portc.5 , E = Portc.4
Cls
Cursor Off

'----------------------------------------------------------------------------------------------------------------
'Definiraj ulaz za Busy:

Busy Alias Pinb.1

Config Busy = Input                                         ' ulaz za Busy sa DF Playera, 1=slobodan , 0= zauzet

'Definiraj velicinu Df_buffera:

Dfbuffer_len Alias 80                                       'velicina Df_buffera u Words za DF Player(80 Words)

'Definiraj pin za prijavu greske prekoracenja Df_buffera , na taj pin spoji LED za Error

Error Alias Portb.2

$include "dfplayer2.inc"

'Language = 1                                                ' 1 = hrvatski , 0 = engleski , u ovom primjeru nevazno
'-------------------------------------------------------------------------------------------------------------------
'Definiranje 5 tipki spojenih na PORTD i GND

Key0 Alias Pind.0
Key1 Alias Pinb.0
Key2 Alias Pind.2
Key3 Alias Pind.3
Key4 Alias Pind.4


Led Alias Portb.2

'Config Led = Output                                         ' vec je definirano  kao izlaz sa DDRB
'--------------------------------------------------------------------------------------------------
'  Dfplayer Volume , 31                                      'opciono promjeni glasnocu sa pocetne 28 na 31 --> maksimum
'  Waitms 200                                                'pauza za izvrsenje naredbe

 Enable Interrupts                                          'omoguci sve definirane interapte

'-------------------------------------------------------------------------------
' Uputa za koristenje naredbe Wait_ms
'-------------------------------------------------------------------------------
' Naredba: Wait_ms
' za interaptsko odredivanje pauze u ms:
' Primjer koristenja:
'                     Time_ms=1000: Wait_ms  ' pauza 1000ms

'Napomena: Naredba Wait_ms pauzira dalje izvrsavanje naredbi za navedeno
'          vrijeme Time_ms isto kao i naredba Waitms, ali je pauza uvijek tocna
'-------------------------------------------------------------------------------
' Uputa za koristenje 32 bitnog brojaca Millis
'-------------------------------------------------------------------------------

' Brojac broji ms od prorade programa. Podatak je u DWord varijabli Millis.
' Prekoracenje nastaje kroz cca.50 dana kad pocne ponovno od nule.
' Koristi se za izvrsavanje delay funkcije i odlaska na neki dio programa
' nakon isteka vremenskog iznosa u ms, a bez blokiranja izvrsavanja Do-Loop petlje

' Primjer kosistenja:

' Svakih ~500ms izvrsava se potprogram Lab_x, te ne zadrzava prolaza
' kroz Do-Loop petlju

' Dim Previous As Dword , Interval As Word , Difference As Dword

' Interval = 500
' Previous = Millis

' Do

' Difference = Millis - Previous

' If Difference >= Interval Then
'    Gosub Lab_x
'    Previous = Millis
' End If

' Loop

'Lab_x:
'       Return
'-------------------------------------------------------------------------------------------------
' Definiranje niza Single varijabli za probni izgovor njihovih iznosa

  Dim X(10) As Single , I As Byte , Y As Single , W As Word , D As Byte , Predznak As Byte , C As Byte

  X(1) = -9999.9 : X(2) = 1.8 : X(3) = 1241 : X(4) = 0 : X(5) = -2.5 : X(6) = 2470.1 : X(7) = 8000 : X(8) = -113.2 : X(9) = 505 : X(10) = -1111.7

  Locate 1 , 1 : Lcd "DF Player Ver2.2"

  Locate 2 , 1 : Lcd "Demo primjer 2"

  Wait 2

Do

   Dfbuffer_enable                                          ' omoguci rad Df buffera

   If Df_flag = 0 Then                                      ' ako nema reprodukcije tada ispisi

    Locate 2 , 1 : Lcd "Select key 0 - 4"

   End If

   Debounce Key0 , 0 , Say_numbers , Sub                    ' izgovori brojcani iznos Single varijable X(i)

   Debounce Key1 , 0 , Numbers_1to10 , Sub                  ' broji od 1 do 10

   Debounce Key2 , 0 , Shallow_mp3 , Sub                    ' demo reprodukcije mp3 "Shallow"

   Debounce Key3 , 0 , Gibonni_mp3 , Sub                    ' demo reprodukcija mp3 Gibonni "Vrime da se pomirimsa svitom"


   If Key4 = 0 Then                                         ' ako je pritisnuta tipka Key4 ukljuci Led

      Set Led

   Else

    Reset Led                                               ' u protivnom iskluci Led

   End If

Loop

'---------------------------------------------------------
Say_numbers:

   If Df_flag = 1 Then Return                               'ako traje prethodna reprodukcija vrati se

   Incr I                                                   ' inkrementiraj indeks I

   If I > 10 Then I = 1                                     ' ako je nakon inkrementiranja indeks I>10 tada je I=1

   Locate 2 , 1 : Lcd "X(" ; I ; ")=" ; Fusing(x(i) , "####.#") ; "        "       ' ispis Single varijable X(i)

   Say_number X(i)                                          ' izgovor brojcanog iznosa Single varijable X(i) preko Df buffera

Return

'-----------------------------------------------------------
Numbers_1to10:

  If Df_flag = 1 Then Return                                'ako traje prethodna reprodukcija vrati se

  Locate 2 , 1

  Lcd "Broji 1 ... 10  "                                    ' ispis "Broji 1 ... 10 "

  Say Broji_1do10                                           ' Broji od 1 do 10

  Return

'------------------------------------------------------------
Shallow_mp3:

  If Df_flag = 1 Then Return                                'ako traje prethodna reprodukcija vrati se

  Locate 2 , 1

  Lcd "Muzika: Shallow "                                    ' za ispis "Muzika: Shallow" u Do-Loop petlji

  Dfbuffer 1002                                             ' preko Df buffera demo reprodukcija mp3 zapisa 1002 , demo mp3 "Shallow"

Return

'-----------------------------------------------------------
Gibonni_mp3:

  If Df_flag = 1 Then Return                                'ako traje prethodna reprodukcija vrati se

  Locate 2 , 1

  Lcd "Muzika: Gibonni "                                    ' ispis "Muzika: Gibonni"

  Say Gibonni                                               ' demo reprodukcija mp3 Gibonni "Vrime da se pomirim sa svitom" naredbom Say Lab_message

  Return

'***************************************************************************

'---------------------------------------------------------------------------
'       Link za dodavanje brzih rutina koje se izvrsavaju svaku 1ms
'---------------------------------------------------------------------------
Every_1ms:


   Return
'---------------------------------------------------------------------------
'      Link za dodavanje brzih rutina koje se izvrsavaju svakih  10ms
'---------------------------------------------------------------------------
Every_10ms:


   Return
'---------------------------------------------------------------------------
'      Link za dodavanje brzih rutina koje se izvrsavaju svakih 100ms
'---------------------------------------------------------------------------
Every_100ms:


   Return
'---------------------------------------------------------------------------
'      Link za dodavanje brzih rutina koje se izvrsavaju svake 1s
'---------------------------------------------------------------------------
Every_1s:

   Toggle Portd.5                                           ' invertiraj izlaz PD.5 svake sekunde za primjer koristenja linka Every_1s

   Return
'---------------------------------------------------------------------------
End                                                         ' Kraj programa

$include "MP3.bas"                                          'MP3.bas datoteka u programu koristenih mp3 zapisa