'********************************************************************************************************
'                   DF PLAYER Ver.2 HW UART - DEMO PRIMJER 5 - ne zaustavlja Do-Loop petlju

' Ovo je DEMO program za ucenje koristenja naredbi DF Playera u Ver.2

' Koristi ATmega328P (moze i ATmega8); radni takt 16MHz (moze i 8MHz)

' VAZNO! Koristi hardverski UART,sa J2 spoji PD.1 i TX, sa J1 spoji PB.0 i Key1

' Ne koristi DS3231 RTC

' Primjer uvjetnog izgovora za slucaj postizavanja zadanog uvjeta za izgovor neke informacije
' uz mogucnost vremenskog ponavljanja izgovora, ako zadani uvjet i dalje je traje.
' Ponavljanje izgovora za Key0  i Key3 ostvareno je pomocu brojaca Millis, a za Key1 pomocu
' brojaca Timer_30s u linku Every_1s.

' Tipka Key0 - izgovara poruku predstavljanja govornika naredbom Say Lab_message,

' a ukoliko se tipka Key0 drzi konstantno pritisnutom ponavlja tu poruku svakih 50 sekundi

' upotrebom brojaca Millis.

' Tipka Key1 - izgovara redom brojeve od 1 do 10 naredbom Say Lab_messsage,

' a ukoliko se tipka Key1 drzi konstantno pritisnutom ponavlja tu poruku svakih 30 sekundi

' pomocu brojaca Timer_30s u linku Every_1s.

' Tipka Key2 - izgovara iznos Single varijable X naredbom Say_number,

' a ukoliko se tipka Key2 drzi konstantno pritisnutom ponavlja taj izgovor svakih 40 sekundi

' upotrebom brojaca Millis.

' Tipka Key3 - naredbom Dfstop prekida izgovor i brise Df buffer.

' Tipkom Key4 - upravlja LED diodom na izlazu PB.2 u Do-Loop petlji (za provjeru izvrsenja Do-Loop petlje).

' Pomocu linka Every_1s invertira izlaz PD.5 svake sekunde.

' Iza naredbe End treba ukljuciti datoteku MP3.bas u programu koristenih mp3 zapisa.

' Naredbe DF playera koje se koriste u ovom primjeru ne koriste varijablu Language.
'----------------------------------------------------------------------------------------------------------
'Koristi Df buffer tako da za vrijeme reprodukcije ne zaustavlja prolaz kroz Do-Loop petlju

'TX = PD.1(hardverski UART) i Busy = PB.1 ; izbor po volji

'Sa $include "dfplayer2.inc" u program ukljuciti slijedece naredbe:

'Time_ms = x : Wait_ms - naredba interaptski izvrsava tocnu pauzu od x ms (zaustavlja Do_Loop)

'Moze se koristiti i 32 bitni brojac Millis koji broji ms od ukljucenja

'Na raspolaganju su i linkovi za brze rutine koje se izvrsavaju u periodi 1ms, 10ms, 100ms i 1s

'Za rad koristi Timer0 prekid, a slobodni su Timer1 i Timer2, treba omoguciti interapte

'Naredbe prije Do-Loop petlje:

'Dfplayer Command , Parameter - naredba slanja komande i opciono parametra na DF player

'najcesca Dfplayer naredba je: Dfplayer Mp3 , x  ; x je broj mp3 zapisa u direktoriju MP3

'Naredbe unutar Do-Loop petlje:

'Dfbuffer_enable - naredba se mora staviti samo jednom na pocetku Do-Loop petlje, a prije
'                  ostalih naredbi za DF player i omogucava pravilan rad Df buffera

'Dfbuffer x  -  naredba za upis u Df buffer ;  x je brojcani naziva mp3 zapisa iz MP3 direktorija

'Dfstop - prekida reprodukciju i brise Df buffer

'Say Lab_message  -  naredba slanja poruke u Df buffer , poruka se nalazi na opcenitoj labeli Lab_message

'Say_number x - izgovor broja iz Single varijable x preko Df buffera (opseg broja je od -9999.9 do 9999.9)

'Say_temperature x - izgovor temperature iz Single varijable x uz izgovor mjerne jedinice za temperaturu

'Say_day - izgovor dana u tjednju sadrzanog u varijabli Day (1=ponedjeljak...7=nedjelja)

'Say_date - izgovor datuma, mjeseca i godine (hrvatski ili englesni standard izgovora)

'iz Byte varijabli Dte, Month i Year (brojevi u dekatskom obliku)

'Say_time - izgovor vremena HH:MM iz Byte varijabli Hour i Minute (sadrzaj u dekatskom obliku)

'Napomena:Za vrijeme trajanja reprodukcije blokiran je upis novih podataka u Df buffer (Df_flag=1)

'U ovom primjeru je LED = PB.2 za isprobavanje rada programa i za ERROR .

'ERROR izlaz za prijavu greske : Buffer overload! (definirano u driveru "dfplayer2.inc")

'Upis u Df buffer radi se u Do-Loop petlji kad je Df_flag=0 (kad nema reprodukcije).

'Citanje Df buffera i slanje podataka na DF player izvrsava se u Timer0 interaptu svakih 150ms.

'Autor: Mladen Cempuh ; E-mail: cempuh.mladen@gmail.com

'Datum: 27.05.2021.
'**********************************************************************************************************
$regfile = "m328pdef.dat"
'$regfile = "m8def.dat"
$crystal = 16000000                                         ' izabrati ili 8MHz ili 16MHz
$swstack = 50
$hwstack = 60                                               ' VAZNO! iznos od 40 nije dovoljan za HWstack! Preporuka: =>60
$framesize = 64

'---------------------------------------------------------
'DEFINIRANJE ULAZA,IZLAZA I POCETNIH STANJA PINOVA PORTOVA
'DDRn   PORTn
' 0       0   ==> Input 3-state
' 0       1   ==> Input
' 1       0   ==> Output=0
' 1       1   ==> Output=1

  Ddrb = &B11111100                                         ' ulaz PB.0 za tipku KEY1,ulaz PB.1 za Busy, PB.2 izlaz za LED, PB3 izlaz za rasvjetu LCD-a
 Portb = &B11001011                                         ' Izlazi za LCD: DB7=PB.4;DB6=PB.5;DB5=PC.2;DB4=PC.3;E=PC.4;RS=PC.5
  Ddrc = &B11111100                                         ' PC.0 i PC.1 su slobodni ulazi
 Portc = &B00000011                                         '
  Ddrd = &B11100010                                         ' Ulazi za tipke KEY0=PD.0;KEY2=PD.2;KEY3=PD.3;KEY4=PD.4
 Portd = &B11111111                                         ' Izlaz PD.1 za TX hardverskog UART-a
                                                            ' PD5,PD6 i PD7 su slobodni za koristenje (startno postavljeni kao izlazi sa stanjem 1)
'---------------------------------------------------------
'DEFINIRANJE LCD DISPLEJA U 4 BITNOM RADU

Config Lcd = 16 * 2
Config Lcdpin = Pin , Db4 = Portc.3 , Db5 = Portc.2 , Db6 = Portb.5 , Db7 = Portb.4 , Rs = Portc.5 , E = Portc.4
Cls
Cursor Off

'----------------------------------------------------------------------------------------------------------------
'Definiraj ulaz za Busy:

Busy Alias Pinb.1

Config Busy = Input                                         ' ulaz za Busy sa DF Playera, 1=slobodan , 0= zauzet

'Definiraj velicinu Df_buffera:

Dfbuffer_len Alias 80                                       'velicina Df_buffera u Words za DF Player(80 Words)

'Definiraj pin za prijavu greske prekoracenja Df_buffera , na taj pin spoji LED za Error

Error Alias Portb.2

$include "dfplayer2.inc"

'Language = 0                                                ' 1 = hrvatski , 0 = engleski , u ovom primjeru nevazno
'--------------------------------------------------------------------------------------------------------------------
'Definiranje 5 tipki spojenih na PORTD i GND

Key0 Alias Pind.0
Key1 Alias Pinb.0
Key2 Alias Pind.2
Key3 Alias Pind.3
Key4 Alias Pind.4


Led Alias Portb.2

'Config Led = Output                                         ' vec je definirano  kao izlaz sa DDRB
'--------------------------------------------------------------------------------------------------
'  Dfplayer Volume , 31                                      'opciono promjeni glasnocu sa pocetne 28 na 31 --> maksimum
'  Waitms 200                                                'pauza za izvrsenje naredbe

 Enable Interrupts                                          'omoguci sve definirane interapte (potrebno zbog Timer0 interapta)

'-------------------------------------------------------------------------------
' Uputa za koristenje naredbe Wait_ms
'-------------------------------------------------------------------------------
' Naredba: Wait_ms
' za interaptsko odredivanje pauze u ms:
' Primjer koristenja:
'                     Time_ms=1000: Wait_ms  ' pauza 1000ms

'Napomena: Naredba Wait_ms pauzira dalje izvrsavanje naredbi za navedeno
'          vrijeme Time_ms isto kao i naredba Waitms, ali je pauza uvijek tocna
'-------------------------------------------------------------------------------
' Uputa za koristenje 32 bitnog brojaca Millis
'-------------------------------------------------------------------------------

' Brojac broji ms od prorade programa. Podatak je u DWord varijabli Millis.
' Prekoracenje nastaje kroz cca.50 dana kad pocne ponovno od nule.
' Koristi se za izvrsavanje delay funkcije i odlaska na neki dio programa
' nakon isteka vremenskog iznosa u ms, a bez blokiranja izvrsavanja Do-Loop petlje

' Primjer kosistenja:

' Svakih ~500ms izvrsava se potprogram Lab_x, te ne zadrzava prolaza
' kroz Do-Loop petlju

' Dim Previous As Dword , Interval As Word , Difference As Dword

' Interval = 500
' Previous = Millis

' Do

' Difference = Millis - Previous

' If Difference >= Interval Then
'    Gosub Lab_x
'    Previous = Millis
' End If

' Loop

'Lab_x:
'       Return
'--------------------------------------------------------------------------------------------------------------------------------------
  Dim Flagbyte(3) As Byte                                   ' niz od 3 bajtna flaga za ponavljanje 3 uvjetna izgovora

  Dim Previous1 As Dword , Interval1 As Word , Difference1 As Dword       ' varijable za vremenska ponavljanja pomocu brojaca Millis

  Interval1 = 50000                                         ' vrijeme ponavljanja Interval1 je 50000ms = 50s

  Dim Previous2 As Dword , Interval2 As Word , Difference2 As Dword       ' varijable za vremenska ponavljanja pomocu brojaca Millis

  Interval2 = 40000                                         ' vrijeme ponavljanja Interval2 je 40000ms = 40s

  Dim Timer_30s As Byte                                     ' bajtni brojac za vrijeme od 30s pomocu linka Evera_1s

  Dim X As Single                                           ' Single varijabla za probni izgovor njenog iznosa

  X = -5123.7

  Locate 1 , 1 : Lcd "DF Player Ver.2 "

  Locate 2 , 1 : Lcd "Demo primjer 5"

  Wait 2 :

Do

   Dfbuffer_enable                                          ' omoguci rad Df_buffera

   If Df_flag = 0 Then                                      ' ako je Df_flag=0 --> nema reprodukcije tada

     If Key0 = 1 And Key1 = 1 And Key2 = 1 And Key3 = 1 And Key4 = 1 Then

       Locate 2 , 1

       Lcd "Press keys 0 - 4"                               ' ispisi "Press keys 0 - 4"

     End If

   End If

'-----------------------------------------------
'Prvi uvjetni izgovor sa ponavljanjem svakih 50s

If Df_flag = 1 Then Goto Lab_skip_1                         ' ako traje reprodukcija preskoci ovaj izgovor

    If Key0 = 0 Then                                        'postignut uvjet, pritisnuta tipka Key0 za izgovor
                                      '
     If Flagbyte(1) = 0 Then                                ' ako je bajtni flag Flagbyte(1)=0 tada

      Previous1 = Millis                                    ' upisi trenutni iznos iz Millis u Previous1 za pocetak mjerenja vremena

      Locate 2 , 1 : Lcd "Tko si ti ?     "                 ' ispisi poruku "Tko si ti ?"

      Say Ja_sam                                            ' i izgovori poruku predstavljanja govornika

      Flagbyte(1) = 1                                       'postavi bajtni flag Flagbyte(1) u 1, za sprijecavanje ponovnog izgovora te poruke

      Goto Lab_skip_1

     End If

     Goto Lab_skip_1

    End If

    Flagbyte(1) = 0                                         ' tipka Key0 nije pritisnuta, postavi Flagbyte(1) u 0 za ponovni izgovor kad je Key0=0

Lab_skip_1:

    Difference1 = Millis - Previous1                        ' izracunaj Difference1

    If Difference1 >= Interval1 Then                        ' ako je Difference 1 >= Interval1 ,proslo je zadano vrijeme ponavljanja

      Flagbyte(1) = 0                                       ' postavi bajtni flag Flagbyte(1) = 0 za omogucavanje ponovnog izgovora

    End If

'------------------------------------------------
'Drugi uvjetni izgovor sa ponavljanjem 30s

If Df_flag = 1 Then Goto Lab_skip_2                         ' ako traje reprodukcija preskoci ovaj izgovor

    If Key1 = 0 Then                                        'postignut uvjet, pritisnuta tipka Key1 za izgovor
                                      '
     If Flagbyte(2) = 0 Then                                ' ako je bajtni flag Flagbyte(2)=0 tada

      Locate 2 , 1 : Lcd "Broji 1 ... 10  "                 ' ispisi poruku "Broji 1 ... 10  "

      Say Broji_1do10                                       ' izgovori brojeve redom od 1 do 10

      Flagbyte(2) = 1                                       'postavi bajtni flag Flagbyte(2) u 1, za sprijecavanje ponovnog izgovora te poruke

      Goto Lab_skip_2

     End If

     Goto Lab_skip_2

    End If

    Flagbyte(2) = 0                                         ' tipka Key1 nije pritisnuta, postavi Flagbyte(2) u 0 za ponovni izgovor kad je Key1=0

Lab_skip_2:

'------------------------------------------------
'Treci uvjetni izgovor sa ponavljanjem 40s

If Df_flag = 1 Then Goto Lab_skip_3                         ' ako traje reprodukcija preskoci ovaj izgovor

    If Key2 = 0 Then                                        'postignut uvjet, pritisnuta tipka Key2 za izgovor
                                      '
     If Flagbyte(3) = 0 Then                                ' ako je bajtni flag Flagbyte(3)=0 tada

      Previous2 = Millis                                    ' upisi trenutni iznos iz Millis u Previous2 za pocetak mjerenja vremena

      Locate 2 , 1 : Lcd "X = " ; Fusing(x , "####.#") ; "     "       ' ispisi iznos varijable X na LCD

      Say_number X                                          ' i izgovori brojcani iznos varijable X

      Flagbyte(3) = 1                                       'postavi bajtni flag Flagbyte(3) u 1, za sprijecavanje ponovnog izgovora broja

      Goto Lab_skip_3

     End If

     Goto Lab_skip_3

    End If

    Flagbyte(3) = 0                                         ' tipka Key2 nije pritisnuta, postavi Flagbyte(3) u 0 za ponovni izgovor kad je Key2=0

Lab_skip_3:

    Difference2 = Millis - Previous2                        ' izracunaj Difference2

    If Difference2 >= Interval2 Then                        ' ako je Difference 2 >= Interval2 ,proslo je zadano vrijeme ponavljanja

      Flagbyte(3) = 0                                       ' postavi bajtni flag Flagbyte(3) = 0 za omogucavanje ponovnog izgovora poruke

    End If
'------------------------------------------------

    If Key3 = 0 Then                                        ' ako je pritisnuta tipka Key3 tada

     Dfstop                                                 ' zaustavi reprodukciju i obrisi Df buffer

    End If


    If Key4 = 0 Then                                        ' ako je pritisnuta tipka Key4 ukljuci Led

      Set Led

   Else

      Reset Led                                             ' u protivnom iskljuci Led

   End If

Loop

'***************************************************************************

'---------------------------------------------------------------------------
'       Link za dodavanje brzih rutina koje se izvrsavaju svaku 1ms
'---------------------------------------------------------------------------
Every_1ms:


   Return
'---------------------------------------------------------------------------
'      Link za dodavanje brzih rutina koje se izvrsavaju svakih  10ms
'---------------------------------------------------------------------------
Every_10ms:


   Return
'---------------------------------------------------------------------------
'      Link za dodavanje brzih rutina koje se izvrsavaju svakih 100ms
'---------------------------------------------------------------------------
Every_100ms:


   Return
'---------------------------------------------------------------------------
'      Link za dodavanje brzih rutina koje se izvrsavaju svake 1s
'---------------------------------------------------------------------------
Every_1s:

    If Flagbyte(2) = 1 Then                                 ' ako je Flagbyte(2)=1 tada pocni mjerenje vremena
     Incr Timer_30s                                         ' uvecaj brojac vremena Timer_30s
      If Timer_30s = 30 Then                                ' ako je proslo 30s tada
        Flagbyte(2) = 0                                     ' postavi uvjetni bajtni flag Flagbyte(2) u 0 za ponovni izgovor
        Timer_30s = 0                                       ' postavi brojac vremena Timer_30s u 0
      End If
    Else                                                    ' u protivnom kad je Flagbyte(2)=0
      Timer_30s = 0                                         ' postavi brojac vremena Timer_30s u 0
    End If

    Toggle Portd.5                                          ' invertiraj izlaz PD.5 svake sekunde

   Return
'---------------------------------------------------------------------------
End                                                         ' Kraj programa

$include "MP3.bas"                                          'MP3.bas datoteka u programu koristenih mp3 zapisa